<?php 
/**
*	@file editor_tab_import-export.php
*	@brief A import/export tab of an administator view editor page.
*	From this tab administrators can import csv files which contains card data.
*/


?>
<?php 
if (isset($_GET['file']) && file_exists('temp/' . $_GET['file'])) {
	
	header('Content-Description: File Transfer');
	header("Pragma: public");
	header("Expires: 0");
	header("Cache-Control: must-revalidate, post-check=0, pre-check=0"); 
	header("Content-type: application/csv");
	//header("Content-Type: application/force-download");
	//header("Content-Type: application/octet-stream");
	//header("Content-Type: application/download");
	header("Content-Disposition: attachment;filename=" . $_GET['file']);
	//header("Content-Transfer-Encoding: binary ");
	header("Content-Transfer-Encoding: UTF-8");
	header('Content-Length: ' . filesize('temp/' . $_GET['file']));
   ob_clean();
   flush();
   readfile('temp/' . $_GET['file']);
   exit;
}
?>
		<div id="editor_import-export">
			
			<?php // Possible notifications of succesful actions ?>
			<?php if (isset($_POST['notifications']['cards_imported'])) :
						if ($_POST['notifications']['cards_imported']) : ?>
			<p class="notification">
				<?php echo localize('ADMIN_EDITOR_NOTIFICATION_CARDS_IMPORTED'); ?>
			</p>
			<?php 	endif; ?>
			<?php endif; ?>
			
			<h2><?php echo localize('ADMIN_EDITOR_IMPORT_CSV')?></h2>
			<form id="import_csv_form" class="admin_form narrow_form" method="post" action="" enctype="multipart/form-data">
				<label for="csv_file"><?php echo localize('ADMIN_EDITOR_CHOOSE_FILE_TO_UPLOAD'); ?><div class="info"><abbr title="<?php echo(localize('INFO_ADMIN_IMPORT_CARDS')); ?>" rel="tooltip">i</abbr></div></label>
				<input type="file" name="csv_file" id="csv_file" value="" />
				<label for="import_csv_language_selector"><?php echo localize('ADMIN_EDITOR_IMPORT_CSV_LANGUAGE_SELECTOR'); ?>:</label>
				<select id="import_csv_language_selector" name="import_csv_language_selector">
					<option value="" disabled="disabled"><?php echo localize('SELECT'); ?></option>
				<?php global $languages;
						// Set card display lang
						if (!isset($_SESSION['card_display_lang'])) {
							$_SESSION['card_display_lang'] = $_SESSION['lang'];
						}
						foreach($languages as $lang):
				?>
					<option value="<?php echo $lang; ?>" <?php if ($lang == $_SESSION['card_display_lang']) echo 'selected="selected"'; ?>><?php echo $lang; ?></option>		
				<?php endforeach; ?>
				</select>
				<br />
				<?php $config = Config::getInstance(); ?>
				<a href="<?php echo($config->baseurl . 'install/sample_cards.csv');?>"><?php echo(localize('EXAMPLE')); ?></a>
				<br /><br />
				<input class="" type="submit" id="import_csv_file" name="import_csv_file" value="<?php echo localize('IMPORT'); ?>" />
				<?php	if (isset($editor_form_errors['editor']['import']['csv_file'])) : ?>
				<p class="error"><?php echo $editor_form_errors['editor']['import']['csv_file']; ?></p>
				<?php endif; ?>
			</form>
			
			<h2><?php echo localize('ADMIN_EDITOR_EXPORT_CARDS')?></h2>
			<form id="export_cards_form" class="admin_form narrow_form small_input" method="post" action="" enctype="multipart/form-data">
				
				<label for="export_cards_language_selector"><?php echo localize('ADMIN_EDITOR_EXPORT_CARDS_LANGUAGE_SELECTOR'); ?>:</label>
				<select id="export_cards_language_selector" name="export_cards_language_selector">
					<option value="" disabled="disabled"><?php echo localize('SELECT'); ?></option>
				<?php global $languages;
						// Set card display lang
						if (!isset($_SESSION['card_display_lang'])) {
							$_SESSION['card_display_lang'] = $_SESSION['lang'];
						}
						foreach($languages as $lang):
				?>
					<option value="<?php echo $lang; ?>" <?php if ($lang == $_SESSION['card_display_lang']) echo 'selected="selected"'; ?>><?php echo $lang; ?></option>		
				<?php endforeach; ?>
				</select>
				<br />
				<div class="result_loading" id="export_cards_loading" style="display:none;"><img src="../img/loading.gif" alt="<?php echo(localize('IMAGE_ALT_LOADING')); ?>" /></div>
				<p class="error" id="export_cards_error" <?php if (!isset($editor_form_errors['editor']['export']['cards'])) : echo 'style="display:none;"'; endif; ?>><?php if (isset($editor_form_errors['editor']['export']['cards'])) : echo $editor_form_errors['editor']['export']['cards']; endif; ?></p>
				<br />
				<input type="submit" id="export_cards" name="export_cards" value="<?php echo localize('EXPORT'); ?>" />
				<br />
			</form>
			
			<h2><?php echo localize('ADMIN_EDITOR_EXPORT_PROFILES')?></h2>
			<form id="export_profiles_form" class="admin_form narrow_form small_input" method="post" action="" enctype="multipart/form-data">
				<div>
					<span class="input_with_button">
						<label for="export_profiles_from"><?php echo(localize('DATE_RANGE')); ?>: </label>
						<input type="text" class="date_input" id="export_profiles_from" name="export_profiles_from" />
						<label for="export_profiles_to">- &nbsp;</label>
						<input type="text" class="date_input" id="export_profiles_to" name="export_profiles_to" />
						<div class="info"><abbr title="<?php echo(localize('INFO_ADMIN_EXPORT_PROFILES')); ?>" rel="tooltip">i</abbr></div>
					</span>
				</div>
				<div class="result_loading" id="profiles_found_loading" style="display:none;"><img src="../img/loading.gif" alt="<?php echo(localize('IMAGE_ALT_LOADING')); ?>" /></div>
				<p class="notification" id="export_profiles_profiles_found" style="display:none;"><span id="export_profiles_count"></span><?php echo(localize('ADMIN_EDITOR_NOTIFICATION_PROFILES_FOUND')); ?></p>
				<p class="error" id="export_profiles_error" <?php if (!isset($editor_form_errors['editor']['export']['player_profiles'])) : echo 'style="display:none;"'; endif; ?>><?php if (isset($editor_form_errors['editor']['export']['player_profiles'])) : echo $editor_form_errors['editor']['export']['player_profiles']; endif; ?></p>
				<br />
				<input type="submit" id="export_profiles" name="export_profiles" value="<?php echo localize('EXPORT'); ?>" />
				<br />
			</form>
			<iframe id="download_frame" style="display:none"></iframe>
		</div>
<?php  ?>