<?php 
/**
*	@file editor_tab_profiles.php
*	@brief A player profiles tab of an administator view editor page.
*	From this tab administrators can view and delete player profiles.
*/


?>
	<p class="notification" id="delete_profile_notification">
		<span id="delete_profile_notification_profile_nbr"></span><?php echo localize('ADMIN_EDITOR_NOTIFICATION_PROFILE_DELETED'); ?>
	</p>
		
	<div class="editor_buttons">
			<span class="editor_button" id="editor_view_profile_button"><a href="#"><?php echo localize('ADMIN_EDITOR_VIEW_PROFILE')?></a></span>
			<span class="editor_button" id="editor_view_profile_button_dummy"><a href="#"><?php echo localize('ADMIN_EDITOR_VIEW_PROFILE')?></a></span>
			<span class="editor_button" id="editor_delete_profile_button"><a href="#"><?php echo localize('ADMIN_EDITOR_DELETE_PROFILES')?></a></span>
			<span class="editor_button" id="editor_delete_profile_button_dummy"><a href="#"><?php echo localize('ADMIN_EDITOR_DELETE_PROFILES')?></a></span>
			<span class="editor_button" id="editor_select_all_button"><a href="#"><?php echo localize('ADMIN_EDITOR_SELECT_ALL')?></a></span>
	</div>
	
	<div class="search_field">
		<label for="player_search"><?php echo localize('SEARCH')?></label>
		<input type="text" name="player_search" id="player_search" value="" />
	</div>
	<?php $config = Config::getInstance(); ?>
	<div id="player_table_loading" class="table_loading" style="display:none;"><img src="<?php echo($config->baseurl); ?>img/loading.gif" alt="<?php echo localize('IMAGE_ALT_LOADING'); ?>" /></div>
		<table class="editor_table" id="player_profile_table">
			<thead class="editor_table_header">
				<tr>
					<th id="editor_profile_created_theader"><?php echo localize('ADMIN_EDITOR_PROFILE_CREATED')?></th>
					<th id="editor_profile_player_name_theader"><?php echo localize('ADMIN_EDITOR_PLAYER_NAME')?></th>
					<th id="editor_profile_id_theader" data-placeholder="<50"><?php echo localize('ADMIN_EDITOR_PROFILE_ID')?></th>
					<th id="editor_profile_played_cards_theader" data-placeholder=">=33"><?php echo localize('ADMIN_EDITOR_PROFILE_PLAYED_CARDS')?></th>
				</tr>
			</thead>
			<tbody class="editor_table_body">
				<?php $profiles = array(); ?>
				<?php $game_id = 0; ?>
				<?php if (isset($_SESSION['admin']['game']['game_id'])) : $game_id = $_SESSION['admin']['game']['game_id']; endif; ?>
				<?php $db = DB::getInstance(); ?>
				<?php $profiles = $db->getAllProfiles($game_id); ?>
				<?php $profile_counter = 1; ?>
				<?php foreach ($profiles as $profile) : ?>
				<tr id="player_profile_<?php echo $profile_counter; ?>">
					<?php // Date format depends on language ?>
					<td><?php echo date(localize('DATE_FORMAT'), strtotime($profile['created'])); ?></td>
					<td><?php echo $profile['player_name']; ?></td>
					<td><?php echo $profile['profile_id']; ?></td>
					<td><?php if ($profile['played_cards'] > 0) : echo $profile['played_cards']; else: echo(0); endif; ?></td>
				</tr>		
				<?php 	$profile_counter++; ?>
				<?php endforeach; ?>
			</tbody>
		</table>
		<div id="player_profile_table_pager" class="pager">
			<form>
				<button class="first"><img src="../img/first.png" alt="|&lt;" /></button>
				<button class="prev"><img src="../img/prev.png" alt="&lt;&lt;" /></button>
				<span class="pagedisplay"></span>
				<button class="next"><img src="../img/next.png" alt="&gt;&gt;" /></button>
				<button class="last"><img src="../img/last.png" alt="&gt;|" /></button>
				<select class="pagesize">
					<option selected="selected" value="10">10</option>
					<option value="25">25</option>
					<option value="50">50</option>
					<option value="100">100</option>
				</select>
				<select class="pagenum">
				</select>
			</form>
		</div>
		<div class="jqmWindow" id="player_profile_modal">
			<a href="#" class="jqmClose" id="player_profile_modal_close"><?php echo localize('CLOSE'); ?></a>
			<h2><?php echo(localize('ADMIN_EDITOR_VIEW_PROFILE')); ?></h2>
			<div id="profile_loading" class="loading"><img src="../img/loading.gif" alt="<?php echo localize('IMAGE_ALT_LOADING'); ?>" /></div>
			<div id="profile_content">
			<form id="player_profile_form" class="admin_form" method="post" action="">
			<label for="profile[modal][name]" id="player_profile_modal_name"><?php echo localize("ADMIN_EDITOR_PLAYER_NAME"); ?> </label>
			<input class="" type="text" name="profile[modal][name]" id="profile[modal][name]" value="" disabled="disabled" />
			<label for="profile[modal][id]" id="player_profile_modal_id"><?php echo localize("ADMIN_EDITOR_PROFILE_ID"); ?> </label>
			<input class="" type="text" name="profile[modal][id]" id="profile[modal][id]" value="" disabled="disabled" />
			<label for="profile[modal][date_created]" id="player_profile_modal_date_created"><?php echo localize("ADMIN_EDITOR_PROFILE_CREATED"); ?> </label>
			<input class="" type="text" name="profile[modal][date_created]" id="profile[modal][date_created]" value="" disabled="disabled" />
			<br />
			<div class="info"><abbr title="<?php echo(localize('INFO_ADMIN_PROFILE_TABLE')); ?>" rel="tooltip">i</abbr></div>
			<table class="editor_table" id="player_profile_modal_table">
			<thead class="editor_table_header">
				<tr>
					<th id="editor_profile_created_theader"><?php echo localize('ADMIN_EDITOR_PROFILE_CARD_RECEIVED')?></th>
					<th id="editor_profile_player_name_theader"><?php echo localize('ADMIN_EDITOR_PROFILE_CHOICE_RESULT')?></th>
					<th id="editor_profile_id_theader"><?php echo localize('ADMIN_EDITOR_PROFILE_STAT_CHANGE')?></th>
				</tr>
			</thead>
			<tbody class="editor_table_body">
			</tbody>
			</table>
			<br />
			<label id="player_profile_modal_stats"><?php echo localize('ADMIN_EDITOR_PROFILE_STATS'); ?>:</label>
			<div id="editor_profile_stats"></div>
			<br />
			<br />
			<button id="delete_profile_button" name="delete_profile_button"><?php echo localize('ADMIN_EDITOR_DELETE_PROFILE')?></button> 
			<br />
			<br />
			</form>
			</div>
		</div>
		
		<div class="jqmWindow" id="played_card_choice_result_modal">
			<a href="#" class="jqmClose" id="played_card_choice_result_modal_close"><?php echo localize('CLOSE'); ?></a>
			<h2><?php echo localize('ADMIN_EDITOR_PLAYED_CARD_CHOICE_RESULT'); ?> <span class="left_margin">(<span id="played_card_choice_result_code"></span>)</span></h2>
			<div id="played_card_choice_result_loading" class="loading"><img src="../img/loading.gif" alt="<?php echo localize('IMAGE_ALT_LOADING'); ?>" /></div>
			<div id="played_card_choice_result_content">
			<form id="played_card_choice_result_form" class="admin_form" action="" method="post">
				<label for="card_choice_result_card_name"><?php echo localize('ADMIN_EDITOR_CARD_NAME'); ?></label>
				<input class="" type="text" name="card_choice_result_card_name" id="card_choice_result_card_name" value=""  disabled="disabled"/>
				<label for="card_choice_result_description"><?php echo localize('ADMIN_EDITOR_CARD_DESCRIPTION'); ?></label>
				<textarea class="" name="card_choice_result_description" id="card_choice_result_description" disabled="disabled"></textarea>
				<label for="card_choice_result_choice"><?php echo localize('CHOICE'); ?></label>
				<textarea name="card_choice_result_choice" id="card_choice_result_choice" disabled="disabled"></textarea>
				<label for="card_choice_result_result"><?php echo localize('APP_SIMULATION_RESULT'); ?></label>
				<textarea name="card_choice_result_result" id="card_choice_result_result" disabled="disabled"></textarea>
			</form>
			</div>
		</div>
		
		<div id="delete_profile_modal" class="jqmDialog jqmdWide">
			<a href="#" class="jqmClose" id="delete_profile_modal_close"><?php echo localize('CLOSE'); ?></a>
			<div class="jqmdBL"><div class="jqmdBR"><div class="jqmdBC">
			<div class="jqmdMSG">
				<br />
				<br />
				<br />
				<div class="centered largeText">
					<?php echo localize('ADMIN_EDITOR_CONFIRM_DELETE_PROFILE_PT1')?>
					<span id="delete_profile_modal_profile_number"></span>
					<?php echo localize('ADMIN_EDITOR_CONFIRM_DELETE_PROFILE_PT2')?>
				</div>
				<br />
				<div class="centered buttons">
					<input type="submit" class="jqmClose" id="delete_profile_modal_yes_button" name="delete_profile_modal_yes_button" value="<?php echo localize("YES"); ?>" />
					<input type="submit" class="jqmClose" id="delete_profile_modal_no_button" name="delete_profile_modal_no_button" value="<?php echo localize("NO"); ?>" />
				</div>
			</div>
			</div></div></div>
		</div>

<?php  ?>