<?php
/**
*	@file DB.class.php
*	@brief Database wrapper because of two different database options: MySQLDB and XMLDB.
*	Uses different password hashing based on PHP version. password_compat.php if version
*	is above 5.3.7 else PasswordHash.php.
*/



/** Config An instance of config class to define which database is selected. */
$config = Config::getInstance();
// Support for legacy php versions
if (version_compare($config->php_version, '5.3.7') >= 0) {
	require(dirname(__FILE__) . '/../../libs/password_compat/password.php');
}
else {
	require(dirname(__FILE__) . '/../../libs/phpass/PasswordHash.php');
	// Base-2 logarithm of the iteration count used for password stretching
	$hash_cost_log2 = 10;
	// Do we require the hashes to be portable to older systems (less secure)?
	$hash_portable = TRUE;
}


// If db is set to be MySQL
if ($config->db_type === 'mysql') {
	class DB extends MySQLDB {
		
	}
}
elseif ($config->db_type === 'xml') {
	class DB extends XMLDB {
		
	}
}