<?php
/**
*	@file settings.php
*	@brief Contains needed settings and default values for GAL2 application.
*	Note: No localization is used in this file.
*/

/* Definitions: */
// Defines the maximum length for a game name.
defined('GAME_NAME_MAX_LENGTH') or define('GAME_NAME_MAX_LENGTH', 50);
// Defines the minimum length for a game name.
defined('GAME_NAME_MIN_LENGTH') or define('GAME_NAME_MIN_LENGTH', 1);
// Defines the maximum length for a user name.
defined('USERNAME_MAX_LENGTH') or define('USERNAME_MAX_LENGTH', 25);
// Defines the minimum length for a user name.
defined('USERNAME_MIN_LENGTH') or define('USERNAME_MIN_LENGTH', 3);
// Defines the maximum length of a password
defined('PASSWORD_MAX_LENGTH') or define('PASSWORD_MAX_LENGTH', 60);
// Defines the minimum length of a password
defined('PASSWORD_MIN_LENGTH') or define('PASSWORD_MIN_LENGTH', 4);
// Defines the maximum length for a card name.
defined('CARD_NAME_MAX_LENGTH') or define('CARD_NAME_MAX_LENGTH', 1000);
// Defines the minimum length for a card name.
defined('CARD_NAME_MIN_LENGTH') or define('CARD_NAME_MIN_LENGTH', 3);
// Defines the maximum length for a card description.
defined('CARD_DESCRIPTION_MAX_LENGTH') or define('CARD_DESCRIPTION_MAX_LENGTH', 5000);
// Defines the maximum length for a card choice text.
defined('CARD_CHOICE_MAX_LENGTH') or define('CARD_CHOICE_MAX_LENGTH', 2000);
// Defines the maximum length for a card result text.
defined('CARD_RESULT_MAX_LENGTH') or define('CARD_RESULT_MAX_LENGTH', 2000);
// Defines the maximum length of a card expert advice.
defined('CARD_ADVICE_MAX_LENGTH') or define('CARD_ADVICE_MAX_LENGTH', 5000);
// Defines the maximum length of a card comment.
defined('CARD_COMMENT_MAX_LENGTH') or define('CARD_COMMENT_MAX_LENGTH', 5000);
// Defines the maximum size for a card attachment (picture) in bytes.
defined('CARD_ATTACHMENT_MAX_SIZE') or define('CARD_ATTACHMENT_MAX_SIZE', 1100000); // n. 1Mb
// Defines the starting tag for getting value of some stat
defined('PLAYER_STAT_TAG_START') or define('PLAYER_STAT_TAG_START', '{@');
// Defines the ending tag for getting value of some stat
defined('PLAYER_STAT_TAG_END') or define('PLAYER_STAT_TAG_END', '}');
// Defines the starting tag for getting conditional text
defined('PLAYER_CONDITIONAL_TEXT_TAG_START') or define('PLAYER_CONDITIONAL_TEXT_TAG_START', '{TEXT_COND');
// Defines the ending tag for getting conditional text
defined('PLAYER_CONDITIONAL_TEXT_TAG_END') or define('PLAYER_CONDITIONAL_TEXT_TAG_END', 'TEXT_COND}');
// Defines the ending tag for getting value of player's name
defined('PLAYER_NAME_TAG') or define('PLAYER_NAME_TAG', '{PLAYER_NAME}');


if (!is_file(dirname(__FILE__) . '/../config.php')) {
	// Redirect to install
	header('Location: install.php');
	exit();
}
require_once(dirname(__FILE__) . '/../config.php');
/** string Default language */
$default_language = 'fi-FI';
/** string Global language variable */ 
$language = $default_language;
/** array Installed languages */
$languages = array();
// read all locale files and store corresponding language code to $languages
if ($handle = opendir(dirname(__FILE__) . '/../locales')) {
	while (false !== ($entry = readdir($handle))) {
		if ($entry != "." && $entry != "..") {
			$languages[] = str_replace('.txt', '', $entry);
		}
	}
	closedir($handle);
}
/** string Default page title */
$default_title = 'GAL2';
/** string Default image folder location */
$default_image_folder = 'games/images/';
/** string Current image folder location */
$image_folder = $default_image_folder;
/** double ID of the main administrator of GAL2 which is used in application. */
$super_admin_id = 0;
/** double Contains an administrator ID that defined during installation and is located in config.php */
global $CONF_SUPER_ADMIN_ID;
if (!empty($CONF_SUPER_ADMIN_ID)) {
	$super_admin_id = $CONF_SUPER_ADMIN_ID;
}