<?php
/**
*	@file install.php
*	@brief Handles GAL2 installation and creation of config.php file.
*/

/** Legacy autoloader */
function my_autoloader($class) {
	include 'general/classes/' . $class . '.class.php';
}
/** 
 * Function to execute mysql commands.
 */
function execute($sql, $link) {
    echo "<p>Executing: $sql =>";
    flush();
    if (mysql_query($sql) === false) {
        echo '<span style="color: red;"> FAILURE: '.mysql_error($link).'</span>';
    } else {
        echo '<span style="color: green;"> SUCCESS</span>';
    }
    echo " </p>";
    flush();
}

/** Function to canonicalize given address. */
function canonicalize($address) {
	
	$address = explode('/', $address);
	$keys = array_keys($address, '..');

	foreach($keys AS $keypos => $key) {
		array_splice($address, $key - ($keypos * 2 + 1), 2);
	}
	$address = implode('/', $address);
	$address = str_replace('./', '', $address);
	return $address;
}

header("Content-Type: text/html; charset=UTF-8");
/** Tells if there was an error during installation. */
$error = false;
/** Tells if application was installed successfully. */
$installed = false;
/** File path where to create config.php file. */
$config_file =  dirname(__FILE__) . '/config.php';
if (!touch($config_file)) {
    exit("ERROR: No permission to write in folder <b>" . dirname(__FILE__) . "</b>. Apache must have permission to write to that folder and it's subfolders in order to application work.");
}
set_time_limit(60000);

if (isset($_POST['install'])) {
	
	// Default xml folder
	$xml_folder = "xml/";
	if (isset($_POST['xml_folder']) && !empty($_POST['xml_folder'])) {
		$xml_folder = $_POST['xml_folder'];
		$xml_folder = str_replace('\\', '/', $xml_folder);
	}
	$port = '';
	if ($_SERVER['SERVER_PORT'] != 80) {
		$port = ':' . $_SERVER['SERVER_PORT'];
	}
	// Create config file
	$config_file_content = '<?php
/* Config file created by install.php during installation
 * File can be different between XML and MySQL database installations
 * */
$CONF_BASEURL = "http://' . canonicalize($_SERVER["SERVER_NAME"] . $port . $_SERVER["REQUEST_URI"] . "/../") . '";
$CONF_DB_TYPE = "' . $_POST['db_type'] . '";
$CONF_MYSQL_HOST = "' . $_POST['mysql_host'] . '";
$CONF_MYSQL_PORT = "' . $_POST['mysql_port'] . '";
$CONF_MYSQL_DATABASE = "' . $_POST['mysql_database'] . '";
$CONF_MYSQL_USER = "' . $_POST['mysql_user'] . '";
$CONF_MYSQL_PASSWORD = "' . $_POST['mysql_password'] . '";
$CONF_XML_BASE_FOLDER = "' . $xml_folder . '";
$CONF_PHP_VERSION = "' . PHP_VERSION . '";
';

	file_put_contents($config_file, $config_file_content);
	
	// If xml database is selected create necessary files
	if (isset($_POST['db_type']) && $_POST['db_type'] == 'xml') {
		
		if (!empty($xml_folder) & !empty($_POST['super_admin_name']) && !empty($_POST['super_admin_password'])) {
			
			$xml_path = dirname(__FILE__) . '/' . $xml_folder;
			// If xml folder doesn't exist create one
			if (!is_dir($xml_path)) {
			
				if (!mkdir($xml_path, 0777, true)) {
					exit("ERROR: Can't create directory. Check file rights." . PHP_EOL);
				}
			}
			// If games -folder doesn't exist create one
			if (!is_dir($xml_path . 'games/')) {
			
				if (!mkdir($xml_path . 'games/', 0777, true)) {
					exit("ERROR: Can't create directory. Check file rights." . PHP_EOL);
				}
			}
			$games_file = $xml_path . 'games.xml';
			$games_content = '<?xml version="1.0" encoding="UTF-8"?>
<games>
</games>';
			file_put_contents($games_file, $games_content);

			$users_file = $xml_path . 'users.xml';
			$users_content = '<?xml version="1.0" encoding="UTF-8"?>
<users>
</users>';
			file_put_contents($users_file, $users_content);

			$latest_ids_file = $xml_path . 'latest_ids.xml';
			$latest_ids_content = '<?xml version="1.0" encoding="UTF-8"?>
<latest_ids>
    <user_id>0</user_id>
    <game_id>0</game_id>
    <card_id>0</card_id>
    <profile_id>0</profile_id>
    <admin_relationship_id>0</admin_relationship_id>
    <played_card_id>0</played_card_id>
    <scenario_id>0</scenario_id>
    <scenario_condition_id>0</scenario_condition_id>
    <criteria_id>0</criteria_id>
    <criteria_condition_id>0</criteria_condition_id>
    <tag_id>0</tag_id>
    <card_translation_id>0</card_translation_id>
    <choice_id>0</choice_id>
    <choice_translation_id>0</choice_translation_id>
    <result_id>0</result_id>
    <result_translation_id>0</result_translation_id>
    <game_texts_translation_id>0</game_texts_translation_id>
</latest_ids>';
			file_put_contents($latest_ids_file, $latest_ids_content);
		}
		else {
			$error = true;
		}
	}
	// If MySQL database is selected create necessary tables
	elseif (isset($_POST['db_type']) && $_POST['db_type'] == 'mysql') {
		
		if (!empty($_POST['mysql_host']) && !empty($_POST['mysql_port']) && !empty($_POST['mysql_user']) && !empty($_POST['mysql_database']) && !empty($_POST['super_admin_name']) && !empty($_POST['super_admin_password'])) {
			
			$link = mysql_connect($_POST['mysql_host'] . ":" . $_POST['mysql_port'], $_POST['mysql_user'], $_POST['mysql_password']);
			if (!$link) {
    			exit('ERROR: Couldn\'t connect to the database: ' . mysql_error() . '. <a href="' . $_SERVER["REQUEST_URI"] . '">Verify given information.</a>');
			}
			
			$db_selected = mysql_select_db($_POST['mysql_database'], $link);
			if (!$db_selected) {
				exit('ERROR: Couldn\'t select the database: ' . mysql_error() . '. <a href="'.$_SERVER["REQUEST_URI"].'">Verify given information.</a>');
			}
			// External functions which handle mysql parsing
			include("install/data.php");
			
			foreach ($sql_query as $sql) {
    			execute($sql, $link);
			}
			mysql_set_charset('utf8',$link);
		}
		else {
			$error = true;
		}
	}
	if (!$error) {
		
		require_once(dirname(__FILE__) . '/general/settings.php');
		// Load classes and create super admin
		spl_autoload_register('my_autoloader');
			
		$db = DB::getInstance();
		$super_admin_id = 0;
		if (isset($_POST['super_admin_name']) && isset($_POST['super_admin_password'])) {
			// Create super admin
			$super_admin_id = $db->createUser($_POST['super_admin_name'], $_POST['super_admin_password']);
		}
		// Save super admin id to the config.php file
		$config_file_append = '$CONF_SUPER_ADMIN_ID = ' . $super_admin_id . ';
?>';
		file_put_contents($config_file, $config_file_append, FILE_APPEND);
		
		$installed = true;
		echo '<h1>GAL2 installed succesfully.</h1>' . PHP_EOL;
		echo '<a href="admin/index.php">You can now login to admin area and start creating your game.</a>' . PHP_EOL;
	}
}
if (!$installed) {
	
	echo '<h1>GAL2 MySQL-version Installation</h1>' . PHP_EOL;
	echo '<p>This is an installer for GAL2. Proceeding further will overwrite all previous settings! 
			It\'s recommended that you remove install.php file after successfull installation so that any unfortunate accidents wouldn\'t occur.
			</p>' . PHP_EOL;
	echo '<p>When installing to MySQL database you must have MySQL user with permissions to create and modify tables in corresponding database created before you can install.</p>' . PHP_EOL;
	if ($error) {
		echo '<p style="color:red;">ERROR: All fields are required.</p>' . PHP_EOL;
	}
	echo '<form method="post">' . PHP_EOL;
	echo '<label for="db_type">Database type:</label>' . PHP_EOL;
	echo '<select name="db_type" id="db_type" onchange="changeDB()" >' . PHP_EOL;
	$db_type = 'mysql';
	if (isset($_POST['db_type'])) {
		$db_type = $_POST['db_type'];
	}
	if ($db_type == 'mysql') {
		echo '<option value="mysql" selected="selected">MySQL</option>' . PHP_EOL;
		//echo '<option value="xml">XML</option>' . PHP_EOL;
	}
	else {
		echo '<option value="mysql">MySQL</option>' . PHP_EOL;
		echo '<option value="xml" selected="selected">XML</option>' . PHP_EOL;
	}
	echo '</select>' . PHP_EOL;
	echo '<fieldset id="mysql_fields"';
	if ($db_type == 'xml') {
		echo ' style="display:none;"';
	}
	echo '>' . PHP_EOL;
   echo '<legend>MySQL</legend>' . PHP_EOL;
	echo '<label for="mysql_host">MySQL database host address:</label>' . PHP_EOL;
	$mysql_host = 'localhost';
	if (isset($_POST['mysql_host'])) {
		$mysql_host = $_POST['mysql_host'];
	}
	echo '<input style="width: 100%;" type="text" name="mysql_host" id="mysql_host" value="' . $mysql_host . '" />' . PHP_EOL;
	echo '<label for="mysql_port">MySQL database port:</label>' . PHP_EOL;
	$mysql_port = 3306;
	if (isset($_POST['mysql_port'])) {
		$mysql_port = $_POST['mysql_port'];
	}
	echo '<input style="width: 100%;" type="text" name="mysql_port" id="mysql_port" value="' . $mysql_port . '" />' . PHP_EOL;
	echo '<label for="mysql_database">MySQL database name:</label>' . PHP_EOL;
	$mysql_database = 'gal2_db';
	if (isset($_POST['mysql_database'])) {
		$mysql_database = $_POST['mysql_database'];
	}
	echo '<input style="width: 100%;" type="text" name="mysql_database" id="mysql_database" value="' . $mysql_database . '" />' . PHP_EOL;
	echo '<label for="mysql_user">MySQL database user name:</label>' . PHP_EOL;
	$mysql_user = '';
	if (isset($_POST['mysql_user'])) {
		$mysql_user = $_POST['mysql_user'];
	}
	echo '<input style="width: 100%;" type="text" name="mysql_user" id="mysql_user" value="' . $mysql_user . '" />' . PHP_EOL;
	echo '<label for="mysql_password">MySQL database password:</label>' . PHP_EOL;
	$mysql_password = '';
	if (isset($_POST['mysql_password'])) {
		$mysql_password = $_POST['mysql_password'];
	}
	echo '<input style="width: 100%;" type="text" name="mysql_password" id="mysql_password" value="' . $mysql_password . '" /><br /><br />' . PHP_EOL;
	echo '</fieldset>' . PHP_EOL;
	echo '<br />' . PHP_EOL;
	echo '<fieldset id="xml_fields"';
	if ($db_type == 'mysql') {
		echo ' style="display:none;"';
	}
	echo '>' . PHP_EOL;
   echo '<legend>XML</legend>' . PHP_EOL;
   echo '<label for="xml_folder">XML folder:</label>' . PHP_EOL;
	$xml_folder = 'xml/';
	if (isset($_POST['xml_folder'])) {
		$xml_folder = $_POST['xml_folder'];
	}
   echo '<input style="width: 100%;" type="text" name="xml_folder" id="xml_folder" value="' . $xml_folder . '" />' . PHP_EOL;
   echo '</fieldset>' . PHP_EOL;
   echo '<fieldset>' . PHP_EOL;
   echo '<legend>Super admin</legend>' . PHP_EOL;
   echo '<label for="super_admin_name">Super admin name:</label>' . PHP_EOL;
	$super_admin_name = '';
	if (isset($_POST['super_admin_name'])) {
		$super_admin_name = $_POST['super_admin_name'];
	}
   echo '<input style="width: 100%;" type="text" name="super_admin_name" id="super_admin_name" value="' . $super_admin_name . '" />' . PHP_EOL;
	echo '<label for="super_admin_password">Super admin password:</label>' . PHP_EOL;
	$super_admin_password = '';
	if (isset($_POST['super_admin_password'])) {
		$super_admin_password = $_POST['super_admin_password'];
	}
	echo '<input style="width: 100%;" type="text" name="super_admin_password" id="super_admin_password" value="' . $super_admin_password . '" /><br /><br />' . PHP_EOL;
   echo '</fieldset>' . PHP_EOL;
	echo '<input type="submit" name="install" value="Install" />' . PHP_EOL;
	echo '</form>' . PHP_EOL;
	echo '<script type="text/javascript">function changeDB() {' . PHP_EOL;
	echo 'var selection = document.getElementById("db_type");' . PHP_EOL;
	echo 'if (selection.options[selection.selectedIndex].value == "mysql") {' . PHP_EOL;
	echo 'document.getElementById("xml_fields").style.display = "none";' . PHP_EOL;
	echo 'document.getElementById("mysql_fields").style.display = "";' . PHP_EOL;
	echo '} else {' . PHP_EOL;
	echo 'document.getElementById("xml_fields").style.display = "";' . PHP_EOL;
	echo 'document.getElementById("mysql_fields").style.display = "none";}' . PHP_EOL;
	echo '}</script>' . PHP_EOL;
	exit;
}

?>